package com.tristate.radarsample;

import android.Manifest;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.location.Location;
import android.location.LocationManager;
import android.os.Handler;
import android.os.Looper;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.os.Bundle;
import android.provider.Settings;
import android.view.LayoutInflater;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;
import android.widget.TextView;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationCallback;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationResult;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.tristate.radarview.LatLongCs;
import com.tristate.radarview.ObjectModel;
import com.tristate.radarview.RadarViewC;

import java.util.ArrayList;



public class MainActivity extends AppCompatActivity {
    int PERMISSION_ID = 44;
    FusedLocationProviderClient mFusedLocationClient;
    public double lat=0;
    public double lng=0;
    ArrayList<ObjectModel> mDataSet = new ArrayList<>();
    private LatLongCs mLatCenter = new LatLongCs(23.0663701, 72.5295074);
    RadarViewC mRadarCustom;
    double centerX=15.879902647193285,centerY= 74.49726531020345;
    //15.879902647193285, 74.49726531020345
    LatLongCs latLongCs =null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mRadarCustom=(RadarViewC)findViewById(R.id.mRadarCustom);

        requestAllPermissions();
        if (checkPermissions()) {
            getLastLocation();
        }
        System.out.println(">>LAT:::"+this.lat+" LNG:"+this.lng);

        animateRadar();
        loadTempData();

    }

    /***********************************/

    private boolean isLocationEnabled() {
        LocationManager locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        return locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER); // || locationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER
    }

    private boolean checkPermissions() {
        return ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED;

        // If we want background location
        // on Android 10.0 and higher,
        // use:
        // ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_BACKGROUND_LOCATION) == PackageManager.PERMISSION_GRANTED
    }

    // method to request for permissions
    private void requestAllPermissions() {
        int PERMISSION_ALL = 1;
        String[] PERMISSIONS = {

                /*android.Manifest.permission.RECEIVE_SMS,*/
                android.Manifest.permission.ACCESS_FINE_LOCATION,

                Manifest.permission.ACCESS_COARSE_LOCATION
        };

        boolean per = hasPermissions(this, PERMISSIONS);
        System.out.println("PERM=" + per);
        if (per == false) {
            ActivityCompat.requestPermissions(this, PERMISSIONS, PERMISSION_ALL);


        }

    }

    public static boolean hasPermissions(Context context, String... permissions) {
        if (context != null && permissions != null) {
            for (String permission : permissions) {
                if (ActivityCompat.checkSelfPermission(context, permission) != PackageManager.PERMISSION_GRANTED) {
                    System.out.println("{{permissions}} " + permission + " NOT GRANTED  ");
                    return false;
                }
            }
        }
        return true;
    }


    @SuppressLint("MissingPermission")
    private void getLastLocation() {
        // check if permissions are given
        if (checkPermissions()) {

            // check if location is enabled
            if (isLocationEnabled()) {

                // getting last
                // location from
                // FusedLocationClient
                // object
                //if(mFusedLocationClient == null)
                    requestNewLocationData();
                /*
                    mFusedLocationClient.getLastLocation().addOnCompleteListener(new OnCompleteListener<Location>() {
                    @Override
                    public void onComplete(@NonNull Task<Location> task) {
                        Location location = task.getResult();
                        location=null;
                        if (location == null) {
                            requestNewLocationData();
                        } else {
//                            latitudeTextView.setText(location.getLatitude() + "");
//                            longitTextView.setText(location.getLongitude() + "");
                            lat=location.getLatitude();
                            lng=location.getLongitude();


                        }
                    }
                });

                 */
            } else {
                //   Toast.makeText(this, "Please turn on" + " your location...", Toast.LENGTH_LONG).show();
                Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
                startActivity(intent);
            }
        } else {
            // if permissions aren't available,
            // request for permissions
            requestPermissions();
        }
    }

    private void requestPermissions() {
        ActivityCompat.requestPermissions(this, new String[]{
                Manifest.permission.ACCESS_COARSE_LOCATION,
                Manifest.permission.ACCESS_FINE_LOCATION}, PERMISSION_ID);
    }
    /*
     if (checkPermissions()) {
            getLastLocation();
        }
     */

    @Override
    protected void onResume() {
        super.onResume();
        if (checkPermissions()) {
            getLastLocation();
        }
    }

    @SuppressLint("MissingPermission")
    private void requestNewLocationData() {

        // Initializing LocationRequest
        // object with appropriate methods
        LocationRequest mLocationRequest = new LocationRequest();
        mLocationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);
        mLocationRequest.setInterval(5);
        mLocationRequest.setFastestInterval(0);
        mLocationRequest.setNumUpdates(1);

        // setting LocationRequest
        // on FusedLocationClient
        mFusedLocationClient = LocationServices.getFusedLocationProviderClient(this);
        mFusedLocationClient.requestLocationUpdates(mLocationRequest, mLocationCallback, Looper.myLooper());
    }
    private LocationCallback mLocationCallback = new LocationCallback() {

        @Override
        public void onLocationResult(LocationResult locationResult) {
            Location mLastLocation = locationResult.getLastLocation();
//            latitudeTextView.setText("Latitude: " + mLastLocation.getLatitude() + "");
//            longitTextView.setText("Longitude: " + mLastLocation.getLongitude() + "");
            lat=mLastLocation.getLatitude();
            lng=mLastLocation.getLongitude();
            //System.out.println("L>>"+lat+" LG>>"+lng);

        }
    };


    /***********/



    private void animateRadar() {
        ImageView mImgRadarBack = findViewById(R.id.mImgRadarBack);
        Animation rotation = AnimationUtils.loadAnimation(MainActivity.this, R.anim.rotate);
        rotation.setFillAfter(true);
        mImgRadarBack.startAnimation(rotation);
    }
    int idx=-1;
    private void loadTempData() {
        mDataSet.clear();
        mRadarCustom.removeAllViews();
        LayoutInflater inflater = (LayoutInflater) getBaseContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);

        View mCenterView = inflater.inflate(R.layout.layout_center, null);
        TextView textView = mCenterView.findViewById(R.id.mTVText);
        textView.setText("ANTH");

        TextView t1 = new TextView(this);
        t1.setText("Road");

        TextView t2 = new TextView(this);
        t2.setText("MSJ");

        TextView t3 = new TextView(this);
        t3.setText("Circle");

        TextView t4 = new TextView(this);
        t4.setText("Cofee");

        TextView t5 = new TextView(this);
        t4.setText("XXX");

        TextView t6 = new TextView(this);
        t6.setText("WOW");

        t1.setTextColor(Color.RED);
        t2.setTextColor(Color.BLUE);
        t3.setTextColor(Color.RED);
        t4.setTextColor(Color.RED);
        t5.setTextColor(Color.BLUE);


        double r=150;

        latLongCs =new LatLongCs(centerX,centerY );
//15.879820092016391, 74.49712583533544
        double lat=15.879820092016391,longi=74.49712583533544;
        double maxdist=0;
        double dist=distance(centerX,centerY,lat,longi);
        if(maxdist <dist) maxdist=dist;
        System.out.println("DIST:"+dist);
        mDataSet.add(new ObjectModel(lat,longi , dist, t2));
        //15.880170951284507, 74.49709364882744
        lat=15.880170951284507;longi=74.49709364882744;
        dist=distance(centerX,centerY,lat,longi);
        if(maxdist <dist) maxdist=dist;
        mDataSet.add(new ObjectModel(lat,longi ,  dist, t3));
        //15.881511499368164, 74.51637680247222
        //15.880253506317588, 74.49673959723944
        lat=15.880253506317588;longi=74.49673959723944;
        dist=distance(centerX,centerY,lat,longi);
        if(maxdist <dist) maxdist=dist;
        mDataSet.add(new ObjectModel(lat,longi ,  dist, t4));
        lat=15.880109034987479;longi=74.49709364882744;
        //15.881815918858639, 74.51686094118843
        //15.880109034987479, 74.49709364882744
        dist=distance(centerX,centerY,lat,longi);
        if(maxdist <dist) maxdist=dist;
        mDataSet.add(new ObjectModel(lat,longi ,  dist, t5));
        lat=15.879716897997683;longi=74.49681469909144;
        //15.881820433551013, 74.51650756015873
        //15.879716897997683, 74.49681469909144
        dist=distance(centerX,centerY,lat,longi);
        if(maxdist <dist) maxdist=dist;
        mDataSet.add(new ObjectModel(lat,longi ,  dist, t6));
        //23.069213, 72.517739
        //
        //mDataSet.add(new ObjectModel(23.070390, 72.519176, 250, t1));
        System.out.println("Max Dist:"+maxdist);


        double lats[]={15.881959099053072,15.88195393940819,15.881859775865935,15.881702406560054,15.88166951377977};
        double longs[]={74.5162963362036,74.51635802700953,74.5164653153677,74.51657595648705,74.51664368226315};
        double l=0,ln=0;
        if (checkPermissions()) {
            getLastLocation();
        }
        //idx
        System.out.println("LAT:::"+this.lat+" LNG:"+this.lng);
        idx++;
        if(idx>=lats.length)
            idx=0;


        if(this.lat != 0 && this.lng != 0 )
        {
         l=this.lat;
         ln=this.lng;
            TextView t9 = new TextView(this);
            t9.setText("YOU");

            //mDataSet.clear();
            System.out.println("L:"+l+" ln:"+ln+" centerX:"+centerX+" "+centerY+" idx:"+idx);
            dist=distance(centerX,centerY,l,ln);
            System.out.println("DISTANCE From Live:"+dist);
            if(maxdist <dist) maxdist=dist;

            mDataSet.add(new ObjectModel(l,ln ,  dist, t9));



        }



        mRadarCustom.setupData(maxdist, mDataSet, latLongCs, mCenterView);

        mRadarCustom.setUpCallBack(new RadarViewC.IRadarCallBack() {
            @Override
            public void onViewClick(Object objectModel, View view) {

                ObjectModel obj= (ObjectModel) objectModel;
                double dist = obj.getmDistance();
                double lat = obj.getmLatitude();
                double lng = obj.getmLongitude();
                TextView t = (TextView) obj.getmView();
                String txt=  t.getText().toString();
                System.out.println("Clicked ... L:"+lat+","+lng+" Dist:"+dist+" LBL:"+txt);
            }
        });


        new Handler(Looper.getMainLooper()).postDelayed(new Runnable() {
            @Override
            public void run() {


                loadTempData();

            }
        }, 10 * 1000);

    }



    private double distance(double lat1, double lon1, double lat2, double lon2) {
        double R = 6371e3; // metres
        double φ1 = lat1 * Math.PI/180; // φ, λ in radians
        double φ2 = lat2 * Math.PI/180;
        double Δφ = (lat2-lat1) * Math.PI/180;
        double Δλ = (lon2-lon1) * Math.PI/180;

        double a = Math.sin(Δφ/2) * Math.sin(Δφ/2) +
                Math.cos(φ1) * Math.cos(φ2) *
                        Math.sin(Δλ/2) * Math.sin(Δλ/2);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));

        double d = R * c;
        return d;
    }
}
